K - Can you find it?

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2141

Give you three sequences of numbers A, B, C, then we give you a number X. Now you need to calculate if you can find the three numbers Ai, Bj, Ck, which satisfy the formula Ai+Bj+Ck = X.

Input There are many cases. Every data case is described as followed: In the first line there are three integers L, N, M, in the second line there are L integers represent the sequence A, in the third line there are N integers represent the sequences B, in the forth line there are M integers represent the sequence C. In the fifth line there is an integer S represents there are S integers X to be calculated. 1<=L, N, M<=500, 1<=S<=1000. all the integers are 32-integers.
Output For each case, firstly you have to print the case number as the form "Case d:", then for the S queries, you calculate if the formula can be satisfied or not. If satisfied, you print "YES", otherwise print "NO".
Sample Input
3 3 3
1 2 3
1 2 3
1 2 3
3
1
4
10
Sample Output
Case 1:
NO
YES
NO

这道题的题意是有三个数组,从每个数组中找到一个数据加起来等于下面的数字。

如果暴力来做思路很简单,三个for循环就可以了,但是这道题的时间范围有要求,暴力绝对超时,用二分就避免了这种问题。

代码如下:

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
#define ll long long
ll a[505],b[505],c[505],d[250005];
int l,n,m,s,k=0,ca=1;
int pan(ll x)//核心代码,二分遍历
{
    int t=0,y=k-1;
    while(t<=y)
    {
        int mi=(t+y)/2;
        if(d[mi]==x)
            return 1;
        else if(d[mi]>x)
            y=mi-1;
        else
            t=mi+1;
    }
    return 0;
}
int main()
{
    while(~scanf("%d%d%d",&l,&n,&m))
    {
        for(int i=0; i<l; i++)
            scanf("%lld",&a[i]);
        for(int i=0; i<n; i++)
            scanf("%lld",&b[i]);
        for(int i=0; i<m; i++)
            scanf("%lld",&c[i]);
        k=0;
        for(int i=0; i<l; i++)//把前两个数组相加
        {
            for(int j=0; j<n; j++)
                d[k++]=a[i]+b[j];
        }
        sort(d,d+k);
        ll sa;
        scanf("%d",&s);
        printf("Case %d:\n",ca++);
        while(s--)
        {
            int flag=0;
            scanf("%lld",&sa);
            for(int i=0; i<m; i++)
            {
                if(pan(sa-c[i]))
                {
                    flag=1;
                    break;
                }
            }
            if(flag==1)
                printf("YES\n");
            else
                printf("NO\n");
        }
    }
}
这道题就是基础的二分省时,我自己也没想到,还是看了学长的代码才发现,自己水平确实下降了。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值